package com.tung.switchyard.rest_demo;

import org.apache.camel.Exchange;
import org.apache.camel.Message;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;

import com.tung.switchyard.rest_demo.dto.Person;

public class HelloRoute extends RouteBuilder {

	private Processor personExchangeProcessor = new ExchangeProcessor();
	
	/**
	 * The Camel route is configured via this method.  The from endpoint is required to be a SwitchYard service.
	 */
	public void configure() {
		from("switchyard://CSHello")
			.choice()
				.when(simple("${body.sex} == true"))
					
					.process(personExchangeProcessor)
					.to("switchyard://CRHelloProcessor?operationName=hiMan")
				.otherwise()
					.process(personExchangeProcessor)
					.to("switchyard://CRHelloProcessor?operationName=hiLady");
	}
	private static class ExchangeProcessor implements Processor {
		@Override
		public void process(Exchange exchange) throws Exception {
			Message messageIn = exchange.getIn();
			Person messageInBody = exchange.getIn().getBody(Person.class);
			Message outMessage = exchange.getOut();
			outMessage.setHeaders(messageIn.getHeaders());
			outMessage.setBody(messageInBody.getName());
		}
	}
}
