package com.tung.switchyard.rest_demo.dto;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlSeeAlso;

@XmlRootElement(name="RESTResponse")
@XmlAccessorType(XmlAccessType.FIELD)
@XmlSeeAlso({Person.class})
public class RESTResponseDTO<T> {
	@XmlElement
	private T payload;
	private ErrorDTO error;
	public T getPayload() {
		return payload;
	}
	public void setPayload(T payload) {
		this.payload = payload;
	}
	public ErrorDTO getError() {
		return error;
	}
	public void setError(ErrorDTO error) {
		this.error = error;
	}
	
	public RESTResponseDTO(T payload, ErrorDTO error) {
		this.payload = payload;
		this.error = error;
	}
	
	public RESTResponseDTO() {}
	
	public static void main(String[] args) throws Exception {
		RESTResponseDTO<Person> responseDTO = new RESTResponseDTO<Person>();
		Person person = new Person(true, "Brian");
		responseDTO.setPayload(person);
		
		JAXBContext context = JAXBContext.newInstance(RESTResponseDTO.class);
		Marshaller marshaller = context.createMarshaller();
		marshaller.marshal(responseDTO, System.out);
		
		
		responseDTO.setPayload(null);
		responseDTO.setError(new ErrorDTO("345", "Something's wrong"));
		marshaller.marshal(responseDTO, System.out);
	}
}
