package com.tung.switchyard.rest_demo.msgcomposer;

import org.apache.log4j.Logger;
import org.switchyard.Exchange;
import org.switchyard.Message;
import org.switchyard.component.common.label.EndpointLabel;
import org.switchyard.component.resteasy.composer.RESTEasyBindingData;
import org.switchyard.component.resteasy.composer.RESTEasyContextMapper;
import org.switchyard.component.resteasy.composer.RESTEasyMessageComposer;

public class RESTCustomMessageComposer extends RESTEasyMessageComposer {

	private static Logger logger = Logger
			.getLogger(RESTCustomMessageComposer.class);

	@Override
	public Message compose(RESTEasyBindingData source, Exchange exchange)
			throws Exception {
		return super.compose(source, exchange);
	}

	@Override
	public RESTEasyBindingData decompose(Exchange exchange,
			RESTEasyBindingData target) throws Exception {
//		target = super.decompose(exchange, target);
		Object content = exchange.getMessage().getContent();
		logger.info("Changing HTTP Status code...");
		System.out.println("Changing HTTP Status code...");
		exchange.getContext().setProperty(RESTEasyContextMapper.HTTP_RESPONSE_STATUS, 541).addLabels(new String[]{EndpointLabel.HTTP.label()});
		target = super.decompose(exchange, target);
		return target;
	}
}
