package com.tung.switchyard.rest_demo;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.switchyard.component.test.mixins.cdi.CDIMixIn;
import org.switchyard.component.test.mixins.http.HTTPMixIn;
import org.switchyard.test.BeforeDeploy;
import org.switchyard.test.SwitchYardRunner;
import org.switchyard.test.SwitchYardTestCaseConfig;
import org.switchyard.test.SwitchYardTestKit;

@RunWith(SwitchYardRunner.class)
@SwitchYardTestCaseConfig(config = SwitchYardTestCaseConfig.SWITCHYARD_XML, mixins = {
		CDIMixIn.class, HTTPMixIn.class })
public class KSHelloTest {

	public static final String BASE_URL = "http://localhost:8089/rest-demo";
	private HTTPMixIn http;
	
	
	/**
	 * Set the specific port to run the embedded deployment
	 */
	@BeforeDeploy
    public void setProperties() {
    	System.setProperty("org.switchyard.component.resteasy.standalone.port", "8089");
        System.setProperty("org.switchyard.component.resteasy.standalone.path", "");
    }

	@Test
	public void hiMan_InputValid_ReturnContainsMr() throws Exception {
		http.setContentType("application/xml");
		final String personName = "Mikey";
        final String personXMLString = "<person xmlns=\"urn:com.tung.switchyard:soap-hello:1.0\"><sex>true</sex><name>" + personName + "</name></person>";
        final String expectedResponseXMLString ="<greetingResponse xmlns=\"urn:com.tung.switchyard:soap-hello:1.0\"><response>Hello Mr." + personName + "</response></greetingResponse>";
        String response = http.sendString(BASE_URL + "/hello", personXMLString, HTTPMixIn.HTTP_POST);
        SwitchYardTestKit.compareXMLToString(expectedResponseXMLString, response);
	}

	@Test
	public void hiLady_InputValid_ReturnContainsLady() throws Exception {
		http.setContentType("application/xml");
		final String personName = "Clara";
        final String personXMLString = "<person xmlns=\"urn:com.tung.switchyard:soap-hello:1.0\"><sex>false</sex><name>" + personName + "</name></person>";
        final String expectedResponseXMLString ="<greetingResponse xmlns=\"urn:com.tung.switchyard:soap-hello:1.0\"><response>Hello lady " + personName + "</response></greetingResponse>";
        String response = http.sendString(BASE_URL + "/hello", personXMLString, HTTPMixIn.HTTP_POST);
        SwitchYardTestKit.compareXMLToString(expectedResponseXMLString, response);
	}

}
